/*** find internet sites from html documents and format  ***/
/*** then on the screen in  a form which can be used by  ***/
/*** the IBM WEBEXPLORER. Output is taged to the end of  ***/
/*** explore.ini to make it show in the quick site list  ***/

/*** For example getsite ibm.htm >>explore.ini *************/

/*** updated to generate netscape bookmark.htm sytle output ****/
/*** switch added to generate netscape  or webexplorer output ***/
/*** -n = netscape output or -w = webexplorer output ************/

/*** Copyright Robert Fernando, robert.fernando@ntlword.com ***/
/*** comments and details on how this program is being *****/
/*** used are kindly requested *****************************/

/*** version 1.2 16/10/97 ********************************/
/*** correct for missing entries problem *****************/
/*** mod 30/10/97 flag added continue in the print entry section ***/
/*** mod to remove carage returns between parts of an entry ********/

/*** version 1.1 27/08/97 ********************************/
/*** compiled with Borland C for OS/2 v2.0 , it should ***/
/*** compile with the dos version ************************/

/* updated 23/10/05 to include extra parameters to add base url */
/* to non href urls in get all urls mode -B , -A switch */

/* includes */
#include "stdio.h"
#include "ctype.h"
#include "malloc.h"
#include "io.h"
#include "fcntl.h"
#include "sys\stat.h"
#include "string.h"


#define ignore 1
#define BUFFER_SIZE 5000*1024
#define quote "\""
#define EOL "\n"    /* end  of line marker */
//#define EOL "\r"    /* end  of line marker */
#define qrefm "quicklist="
#define nsqrefm "<DT><A HREF="
#define inetlink "://"
#define sinetlink 3
#define inetflink "file://"
#define sinetflink 7


#define debugpos 0   /*** display position of the text 2 = eol marks **/

int FIND_TEXT(char *text);

/*** global vars ***********/
   char *buffer;
   char *bufferst;
   int  LOCATION;
   int   http=0;    /**** pointer to start of href text ****/
   int   bhttp=0;    /**** pointer to http word ****/
   int   qref=0;
   int   bytes_read=0;
/************************/


int main(int argc, char *argv[]) // char *envp[])
{
//   FILE *fp;
   int   input_handle;
   int position=0;
//   char  *temp;
   char  filename[512];
   char  httpt[10000];
   char  newhttpt[10000];
   char  qreft[10000];
   char  baseurl[10000];
   int   size=0;
   int   mode=0;
   int 	 allhrefs =0;
   char  *nothttpref=0;
   int   notfileref=0;
   int   showsite=0;

   int   junk=0;
   int   deleted=0;
   int   pos;

   baseurl[0]='\0'; /*reset base ur to empty string*/

/*** find <a ******/
/*** find href *****/
/*** find =" ******/
/*** step forward to text and save pointer ***/
/*** find next > ****/
/*** step back to find " dec pointer and save ***/

if (argc <2){
printf("\nWelcome to GETSITE V1.2 by Robert Fernando (rfernando@enterprise.net)\n");
printf("\nSyntax getsite filename [-N|-W]\n");
printf("where -W = webexplorer -N = Netscape  DEFAULT = NETSCAPE\n");
printf("eg getsite ibm.htm -N\n");
printf("will convert the file ibm.htm to NETSCAPE BOOKMARK format\n");
printf("-A get all urls includings ones with out hrefs\n");
printf("-B url append url to all urls without href\n");

  return (99);
            }
strcpy(filename,argv[1]);
for (pos=2;pos <(argc);pos++)
{
   	switch (argv[pos][0])
	{	
		case '-':
		{
			switch(toupper(argv[pos][1]))
		 	{
				case 'F':
					printf("\n%s\n",filename);			
					break;
				case 'N':
					mode=0;
					break;
				case 'W':
					mode=1;
					break;
				case 'A':
					allhrefs=1;
					break;
				case 'B':
					if (pos+1<argc)
					if (argv[pos+1][0] !='-') {
						sprintf(baseurl,"%s",argv[pos+1]);
						pos=pos+1; /*step onto filename*/
					}
				case 'S':
					showsite=1;
					break;
			}
			break;
		}
	}
	 
} /* end for */

printf("Base url %s\n",baseurl);

   /* allocate memory for the disk buffer */
   if ((buffer = (char *) malloc(BUFFER_SIZE+1)) == NULL) {
      /* error */
      printf("Error: Insufficient memory to perform test.\n");
      return -1;
   }
    else{
      /* open the file input */
      if ((input_handle = open(filename, O_RDONLY | O_TEXT )) == -1) {
         /* error */
         printf("Error: Failed to open '%s'.\n", filename);
         return -1;
      }
      else {
        bufferst=buffer;
        bytes_read = read(input_handle, buffer, BUFFER_SIZE);

do{
position = FIND_TEXT(qrefm);   /*** qref=  webexplore****/
#if debugpos ==1
if (position !=-1){
printf("position = %d ",position);
                  }
#endif

                if( position !=-1){
qref=position+strlen(qrefm);
position = FIND_TEXT(EOL);    /**** official end of quick ref ****/

if( position !=-1){            /**** eol found read quick ref ****/

#if debugpos ==2
//printf("EOL found\n %s ",(char *)((position-5)+bufferst));
printf("QREF EOL found\n");
#endif

size=position-qref;
//printf("size %d \n",size);

//mod 30/10/97 is the first char a cariage return may be required
for (junk=qref;junk <position+1; junk++){
     if (*(junk+bufferst) >=' ') break;
                                      }
     qref=junk; //store postion of start of quick link text

memset(qreft,0,1000);
strncpy(qreft,(char *)(qref+bufferst),size);  /**** grab site quick ref ***/
strcat(qreft,"\0");
                 }

deleted=0;
for (junk=qref;junk <position+1; junk++){
     if (*(junk+bufferst) <' '){

     #if debugpos ==2
     printf("%s\n",qreft);
     printf("%x",*(junk+bufferst));
     #endif

    if ((unsigned)junk+1<strlen(qreft)){  //last char junk
    strncpy(&qreft[junk-qref],(char *)(junk+1+bufferst),(position-junk)-1);  /**** del char ***/

     #if debugpos ==2
     printf("%s\n",qreft);
     #endif
      deleted++;
                             }
                               }
                                        }
      qreft[strlen(qreft)-deleted]='\0';

#if debugpos==1
printf("\nFOUND QREF = %s\n",qreft);
#endif
     http=position+1;
     position = FIND_TEXT(EOL);    /**** look for next end of line ***/

if (position !=-1){               /***** grab site link ****/

#if debugpos ==2
printf("LINK EOL found\n");
#endif

size=position-http;
//printf("size %d \n",size);
memset(httpt,0,1000);
strncpy(httpt,(char *)(http+bufferst),size);  /**** grab site text ***/
strcat(httpt,"\0");


//generate entries for regular file not converting webshere quicklinks etc
#if debugpos==1
printf("Found site = %s\n",httpt);
#endif

//mod 14/09/07 rpf
if (showsite==1 &&(position !=-1)){

		 printf("\n\nFound site = %s\n\n",httpt);
		}



if (position !=-1){
            if (mode ==0) printf("%s\"%s\" ADD_DATE=\"844061076\" LAST_VISIT=\"844266767\" LAST_MODIFIED=\"844061012\">%s</A>\n",nsqrefm,httpt,qreft);
              else printf("%s %s\n%s\n",qrefm,qreft,httpt); /**** webex **/
              /*** mod 30/10/97 ****/
              //buffer++;
              continue;
                   }
//end of generate rather than convert links

else {
     buffer++;
     continue;
     }
                   }

                        }  /**** end of qref webex style site lists****/

position = FIND_TEXT("<a ");   /*** note <a can be <address> ****/
//printf("start");
if (position ==-1) {
       buffer++;
       continue;
                   }

if (position !=-1){

#if debugpos ==2
printf("<A found\n");
#endif

position = FIND_TEXT("href");
                 }

if (position ==-1) {
       buffer++;
       continue;
                   }

//printf("%d",position);
if (position !=-1){
position = FIND_TEXT("=");
                 }

#if debugpos ==1
if (position !=-1){
printf("position = %d\n",position);
                  }
#endif

if (position ==-1) {
       buffer++;
       continue;
                   }

bhttp=position+1;

if (position !=-1){
position = FIND_TEXT(quote);
                 }

if (position ==-1){
http=bhttp;
position = FIND_TEXT(">");
buffer=buffer -2;   /*** force refind ***/
                  }
else
  if (position !=-1){
     http=position+1;
     position = FIND_TEXT(quote);

#if debugpos ==1
if (position !=-1){
printf("position = %d\n",position);
                  }
#endif
if (position <0){

/**** no ending " / second " but > exists ****/
buffer=http+bufferst; /**** reset for damaged value on no second " ***/
position = FIND_TEXT(">");

#if debugpos ==1
printf("position = %d\n",position);
#endif

#if ignore !=1
if (position ==-1) {
       buffer++;
       continue;
                   }
#endif

if (position <0){ /*** no end of href " or > ***/
       buffer++;
       continue;
                }

buffer=buffer-2; /*** step back past > for refind bellow ***/

#if ignore ==1
if ((position-http)<05){
                   http=bhttp;   /*** found "> text of form href=   "> ***/
                   position=position-1;       /*** set start of text at pos = +1 ******/
                        }
#endif
               }

                 }  /**** endif quote found *****/

if (position !=-1){
size=position-http;
//printf("size %d \n",size);
memset(httpt,0,1000);
strncpy(httpt,(char *)(http+bufferst),size);  /**** grab site text ***/
strcat(httpt,"\0");

#if debugpos ==1
printf("\n%s,httpt");
#endif

	nothttpref=strstr(httpt,inetlink);
	notfileref=strnicmp(httpt,inetflink,sinetflink);

if (allhrefs ==0)
{
	if (nothttpref==0 || notfileref==0) goto notasite;
}

position = FIND_TEXT(">");
//goto fqref;
                 }
else
   if (position ==-1) {
       buffer++;
       continue;
                   }

//fqref:;

if (position !=-1){
qref=position+1;
position = FIND_TEXT("</a>");    /**** official end of site ref ****/
                 }

if (position <0){
position = FIND_TEXT("/a>");     /**** end of site ref missing < ****/
                 }

//mod 30/10/97 is the first char a charage return may be required here

for (junk=qref;junk <position+1; junk++){
     if (*(junk+bufferst) >=' ') break;
                                      }
     qref=junk; //store postion of start of quick link text

if (position !=-1){
size=position-qref;
//printf("size %d \n",size);
memset(qreft,0,1000);
strncpy(qreft,(char *)(qref+bufferst),size);  /**** grab site quick ref ***/
strcat(qreft,"\0");
                 }
#if ignore ==1            //delete control codes in the text
deleted=0;
for (junk=qref;junk <position+1; junk++){
     if (*(junk+bufferst) <' ') {
      strncpy(&qreft[junk-qref],(char *)(junk+1+bufferst),(position-junk)-1);  /**** del char ***/
      deleted++;
      //strcat(qreft,"\0");
                                }
                                      }
     if (deleted >0){
     qreft[strlen(qreft)-deleted]='\0';
                    }
#endif

//test for alt = and set qref to point to it
//code could be added here to extract ALT text in IMG tags
//only required for site extraction code and not for conversion webex to
//netscape


/* updated to add base url to links without http ref */

if (allhrefs ==1)
{
	if (nothttpref==0 || notfileref==0)
	{
		sprintf(newhttpt,"%s/%s",baseurl,httpt);
		sprintf(httpt,"%s",newhttpt);
	}
}


//mod 14/09/07 rpf
if (showsite==1&&(position !=-1)){

		 printf("\n\nFound site = %s\n\n",httpt);
		}


if (mode==1 && (position !=-1)) printf("%s %s\n%s\n",qrefm,qreft,httpt); /**** webex **/

else
if (position !=-1) printf("%s\"%s\" ADD_DATE=\"844061076\" LAST_VISIT=\"844266767\" LAST_MODIFIED=\"844061012\">%s</A>\n",nsqrefm,httpt,qreft);
else {
     buffer++;
     continue;
     }

notasite:;   /*** other href found ***/
      }while(buffer<bufferst+bytes_read);
           } /** endif file found error opening **/
    }/*** end if file found and opened **/
close(input_handle);
return (0);     /**** exit ***/
}


int FIND_TEXT(char *text)
{
   char  *temp;
   char  *text2;
   char  *buffer2;
   char  *LOCATION;

LOCATION =0;

buffer2=buffer;
text2=text;

for (temp=buffer2;temp <(bufferst+bytes_read);temp++ ) {

    if ((temp+strlen(text2))>(bufferst+bytes_read)){
                   LOCATION =0;
                   break;
                                                   }

#if debugpos==1
printf("%c",*temp);
#endif

/***** newline junk *****/ /*was disabled */
#if ignore !=1
 if (strncmp(text2,"\n",1)!=0){
      if (strncmp(temp,"\n",1)==0){

     #if debugpos ==1
     printf("newline found at pos %d\n",temp-bufferst);
     #endif
                   LOCATION =0;  /**** newline found junk found location **/
                   break;        /**** and we are not searching for newline ***/
                                  }
                               }
#endif

    LOCATION = (char *)strnicmp(temp,text2,strlen(text2));

if (LOCATION ==0) {
                  LOCATION=temp;
                  break;
                  } /* endif */
                                                        } /* endfor */
if (LOCATION !=0) {
buffer=LOCATION+1; /* update to start search at current pos+1 on next call ****/

return LOCATION-bufferst;
} else {
   return -1;
       } /* endif */
}


